﻿using DTcms.Common;
using DTcms.Web.UI;
using System;
using System.Collections.Generic;
using System.Text;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Data;

namespace DTcms.Web.Plugin.ArticlePublish.admin
{
    public partial class article_publish_category_edit : Web.UI.ManagePage
    {
        private int id;
        protected string parentallowgroupidlist = "";
        protected int category_id = 0;

        protected void Page_Load(object sender, EventArgs e)
        {
            this.id = DTRequest.GetQueryInt("id");
            if (this.id == 0)
            {
                JscriptMsg("传输参数不正确！", "back");
                return;
            }
            
            if (!Page.IsPostBack)
            {
                AllowUserGroup();
                parentallowgroupidlist = GetParentAllowUserGroupID(this.id);
                ShowInfo(this.id);
            }
        }

        #region 绑定可访问会员组=========================
        private void AllowUserGroup()
        {
            DTcms.BLL.user_groups bll = new DTcms.BLL.user_groups();
            DataTable dt = bll.GetList(0, "", "id asc").Tables[0];
            this.cblAllowUserGroupID.Items.Clear();
            foreach (DataRow dr in dt.Rows)
            {
                this.cblAllowUserGroupID.Items.Add(new ListItem(dr["title"].ToString(), dr["id"].ToString()));
            }
        }
        #endregion

        #region 赋值操作=================================
        private void ShowInfo(int _id)
        {
            BLL.article_publish_category bll = new BLL.article_publish_category();
            Model.article_publish_category model = bll.GetModel(_id);
            category_id = model.category_id;
            if (model.category_id > 0)
            {
                lblTitle.Text = new DTcms.BLL.article_category().GetModel(model.category_id).title;
            }
            else
            {
                lblTitle.Text = new DTcms.BLL.channel().GetModel(model.channel_id).title;
            }
            if (model.is_allow == 1)
            {
                cbIsAllow.Checked = true;
            }
            
            //如果值相等，则选中该项
            if (!string.IsNullOrEmpty(model.allow_usergroupid_list))
            {
                string[] idlist = model.allow_usergroupid_list.Split(',');
                foreach (string id in idlist)
                {
                    foreach (ListItem listItem in cblAllowUserGroupID.Items)
                    {
                        if (id == listItem.Value)
                            listItem.Selected = true;
                    }
                }
            }
        }
        #endregion

        #region 获取上一级允许的会员组===================
        private string GetParentAllowUserGroupID(int id)
        {
            Model.article_publish_category model = new Model.article_publish_category();
            BLL.article_publish_category bll = new BLL.article_publish_category();
            model = bll.GetModel(id);
            
            if (model.category_id > 0)
            {
                DTcms.Model.article_category dtmodel = new DTcms.Model.article_category();
                dtmodel = new DTcms.BLL.article_category().GetModel(model.category_id);
                return bll.GetList("channel_id=" + model.channel_id + " and category_id=" + dtmodel.parent_id).Tables[0].Rows[0]["allow_usergroupid_list"].ToString();
            }
            return ",";
        }
        #endregion

        #region 修改操作=================================
        private bool DoEdit(int _id)
        {
            bool result = false;
            string newusergroupidlist = "";

            BLL.article_publish_category bll = new BLL.article_publish_category();
            Model.article_publish_category model = bll.GetModel(_id);

            model.is_allow = 0;
            if (cbIsAllow.Checked == true)
            {
                model.is_allow = 1;
            }


            if (model.is_allow == 0)  //取消下级
            {
                List<int> idlist = bll.GetChildIDList(_id);
                if (idlist != null || idlist.Count > 0)
                {
                    foreach (int tid in idlist)
                    {
                        Model.article_publish_category item = bll.GetModel(tid);
                        item.is_allow = 0;
                        bll.Update(item);
                    }
                }
                
            }






            if (bll.Update(model))
            {
                result = true;
            }
            
            //获取选中的用户列表
            for (int i = 0; i < cblAllowUserGroupID.Items.Count; i++)
            {
                if (cblAllowUserGroupID.Items[i].Selected)
                {
                    newusergroupidlist += cblAllowUserGroupID.Items[i].Value + ",";
                }
            }
            

            #region 更新本级及下级允许的用户组ID
            List<int> childidlist = new BLL.article_publish_category().GetChildIDList(id);
            childidlist.Add(id);
            foreach (int tempid in childidlist)
            {
                Model.article_publish_category tmodel = bll.GetModel(tempid);

                List<string> strNeedAddUserGroupID = new List<string>();  //需要增加的ID;
                List<string> strNeedDeleteUserGroupID = new List<string>(); //需要删除的ID;
                List<string> strCommonUserGroupID = new List<string>(); //共同的ID;
                Screening(newusergroupidlist, model.allow_usergroupid_list, ref strNeedAddUserGroupID, ref strNeedDeleteUserGroupID);


                //增加操作
                if (strNeedAddUserGroupID != null && strNeedAddUserGroupID.Count > 0)
                {
                    foreach (string aid in strNeedAddUserGroupID)
                    {
                        if (tempid != id)
                        {
                            Model.article_publish_category pmodel = bll.GetModel(tempid);
                        }
                        if (tmodel.allow_usergroupid_list == "")
                        {
                            tmodel.allow_usergroupid_list = ",";
                        }
                        if (tmodel.allow_usergroupid_list.IndexOf("," + aid + ",") < 0)
                        {
                            tmodel.allow_usergroupid_list = tmodel.allow_usergroupid_list + aid + ",";
                        }
                    }
                }
                //删除操作
                if (strNeedDeleteUserGroupID != null && strNeedDeleteUserGroupID.Count > 0)
                {
                    foreach (string did in strNeedDeleteUserGroupID)
                    {
                        if (tmodel.allow_usergroupid_list.IndexOf("," + did + ",") > -1)
                        {
                            tmodel.allow_usergroupid_list = tmodel.allow_usergroupid_list.Replace("," + did + ",", ",");
                        }
                        
                    }
                }

                bll.Update(tmodel);
            }
            #endregion
       
            
            return result;
        }
        #endregion


        #region 筛选操作
        private void Screening(string strNewUserGroupIDList, string strOldUserGroupIDList, ref List<string> strNeedAddUserGroupID, ref List<string> strNeedDeleteUserGroupID)
        {
            List<string> strCommonUserGroupID = new List<string>(); //共同的ID;
            if (!string.IsNullOrEmpty(strNewUserGroupIDList))
            {
                if (strNewUserGroupIDList != strOldUserGroupIDList)
                {
                    string[] newlist = strNewUserGroupIDList.Split(',');

                    #region 找出共同的部分
                    foreach (string nid in newlist)
                    {
                        if (nid != "")
                        {
                            if (!string.IsNullOrEmpty(strOldUserGroupIDList))
                            {
                                string[] oldlist = strOldUserGroupIDList.Split(',');
                                foreach (string oid in oldlist)
                                {
                                    if (nid == oid)
                                    {
                                        strCommonUserGroupID.Add(oid);
                                    }
                                }
                            }
                        }
                    }
                    #endregion

                    #region 筛选出需要添加的id
                    foreach (string nid in newlist)
                    {
                        if (nid != "")
                        {
                            int tempcount = 0;
                            if (strCommonUserGroupID != null && strCommonUserGroupID.Count > 0)
                            {
                                foreach (string tid in strCommonUserGroupID)
                                {
                                    if (nid == tid)
                                    {
                                        tempcount = 1;
                                    }
                                }
                            }
                            if (tempcount < 1)
                            {
                                strNeedAddUserGroupID.Add(nid);
                            }
                        }
                    }
                    #endregion

                    #region 筛选出需要删除的id
                    if (!string.IsNullOrEmpty(strOldUserGroupIDList))
                    {
                        string[] oldlist = strOldUserGroupIDList.Split(',');
                        foreach (string oid in oldlist)
                        {
                            if (oid != "")
                            {
                                int tempcount = 0;
                                if (strCommonUserGroupID != null && strCommonUserGroupID.Count > 0)
                                {
                                    foreach (string tid in strCommonUserGroupID)
                                    {
                                        if (oid == tid)
                                        {
                                            tempcount = 1;
                                        }
                                    }
                                }
                                if (tempcount < 1)
                                {
                                    strNeedDeleteUserGroupID.Add(oid);
                                }
                            }
                        }
                    }
                    #endregion
                }
            }
            else
            {
                if (!string.IsNullOrEmpty(strOldUserGroupIDList))
                {
                    string[] oldlist = strOldUserGroupIDList.Split(',');
                    foreach (string oid in oldlist)
                    {
                        if (oid != "")
                        {
                            strNeedDeleteUserGroupID.Add(oid);
                        }
                    }
                }
            }
        }
        #endregion

        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            if (!DoEdit(this.id))
            {
                JscriptMsg("保存过程中发生错误啦！", string.Empty);
                return;
            }
            JscriptMsg("修改信息成功！", "article_publish_category_list.aspx");
        }


        
    }
}