﻿using System;
using System.Text;
using System.Data;
using System.Web;
using DTcms.Common;
using System.Web.SessionState;
using Newtonsoft.Json;
using System.Collections.Generic;

namespace DTcms.Web.Plugin.ArticlePublish
{
    public class ajax : IHttpHandler, IRequiresSessionState
    {
        
        public void ProcessRequest(HttpContext context)
        {
            //取得处事类型
            string action = DTRequest.GetQueryString("action");
            switch (action)
            {
                case "delete_article":
                    delete_article(context);
                    break;
                //case "synchronous_article_publish_category_data": //同步类别数据
                //    synchronous_article_publish_category_data(context);
                //    break;
                //case "set_category_config": //设置类别数据
                //    set_category_config(context);
                //    break;
                
            }

        }

        public void delete_article(HttpContext context)
        {
            //检查用户是否登录
            DTcms.Model.users model = new DTcms.Web.UI.BasePage().GetUserInfo();
            if (model == null)
            {
                context.Response.Write("{\"status\":0, \"msg\":\"对不起，用户尚未登录或已超时！\"}");
                return;
            }
            string check_id = DTRequest.GetFormString("checkId");
            if (string.IsNullOrEmpty(check_id))
            {
                context.Response.Write("{\"status\":0, \"msg\":\"删除失败，请检查传输参数！\"}");
                return;
            }
            string[] arrId = check_id.Split(',');
            for (int i = 0; i < arrId.Length; i++)
            {
                int id = Utils.StrToInt(arrId[i], 0);
                if (id > 0)
                {
                    DTcms.Model.article articlemodel = new DTcms.BLL.article().GetModel(id);
                    if (model.user_name != articlemodel.user_name)
                    {
                        context.Response.Write("{\"status\":0, \"msg\":\"删除失败，只能删除自己的稿件！\"}");
                        return;
                    }
                    new DTcms.BLL.article().Delete(id);
                }
            }
            context.Response.Write("{\"status\":1, \"msg\":\"删除稿件成功！\"}");
            return;
        }

        ///// <summary>
        ///// 同步网页视图的数据
        ///// </summary>
        //public void synchronous_article_publish_category_data(HttpContext context)
        //{
        //    //检查数据量是否匹配，如果不匹配则重新刷新列表
        //    BLL.article_publish_category bll = new BLL.article_publish_category();
        //    DataTable dt_webcategorylist //= bll.GetWebCategoryList();
        //    DataSet ds = bll.GetAllList();
        //    if (ds == null && ds.Tables[0] == null)
        //    {
        //        context.Response.Write("{\"status\": 1, \"msg\": \"无数据\", \"list\": null}");
        //        return;
        //    }
        //    DataTable dt_categorylist = ds.Tables[0];
        //    if (dt_webcategorylist != null)
        //    {
        //        foreach (DataRow drw in dt_webcategorylist.Rows)
        //        {
        //            foreach (DataRow drc in dt_categorylist.Rows)
        //            {
        //                if (drw["channel_id"].ToString() == drc["channel_id"].ToString() && drw["category_id"].ToString() == drc["category_id"].ToString())
        //                {
        //                    drw["is_allow"] = drc["is_allow"];
        //                    drw["allow_usergroupid_list"] = drc["allow_usergroupid_list"];
        //                    drw["allow_usergroupname_list"] = GetUserNameList(drc["allow_usergroupid_list"].ToString());
        //                }
        //            }             
        //        }
        //        context.Response.Write("{\"status\": 1, \"msg\": \"返回成功\",\"list\": " + JsonConvert.SerializeObject(dt_webcategorylist) + "}");
        //        return;
            
        //    }
        //    context.Response.Write("{\"status\": 0, \"msg\": \"未知错误！\"}");
        //    return;
        //}

        ///// <summary>
        ///// 设定值
        ///// </summary>
        //public void set_category_config(HttpContext context)
        //{
        //    int is_allow = 0;
        //    string strnewusergroupidlist = DTRequest.GetString("strusergroupidlist");
        //    if (string.IsNullOrEmpty(DTRequest.GetString("cid")))
        //    {
        //        context.Response.Write("{\"status\": 0, \"msg\": \"参数错误！\"}");
        //        return;
        //    }
        //    int cid = int.Parse(DTRequest.GetString("cid"));
        //    if (!string.IsNullOrEmpty(DTRequest.GetString("is_allow")))
        //    {
        //        is_allow = int.Parse(DTRequest.GetString("is_allow"));
        //    }
        //    BLL.article_publish_category bll = new BLL.article_publish_category();
        //    DataTable dt_webcategorylist = bll.GetWebCategoryList();//站点所有的频道和类别
        //    DataSet ds = bll.GetAllList();

        //    //查询操作的channel_id和category_id
        //    DataRow[] findweb = dt_webcategorylist.Select("id='" + cid + "'");
        //    int channel_id = 0;
        //    int category_id = 0;
        //    if (findweb != null)
        //    {
        //        channel_id = int.Parse(findweb[0]["channel_id"].ToString());
        //        category_id = int.Parse(findweb[0]["category_id"].ToString());
        //    }
        //    //获取需操作表数据的id
        //    int id = 0;
        //    string allowuserid = "";
        //    DataTable dt = ds.Tables[0];
        //    DataRow[] needdr = dt.Select("channel_id='" + channel_id + "' and category_id='" + category_id + "'");
        //    if (needdr != null)
        //    {
        //        id = int.Parse(needdr[0]["id"].ToString());
        //        allowuserid = needdr[0]["allow_usergroupid_list"].ToString();
        //    }


        //    //设置是否允许投稿操作
        //    if (is_allow == 1)//选中操作
        //    {
        //        List<int> parentidlist = new BLL.article_publish_category().GetParentIDList(id);
        //        parentidlist.Add(id);
        //        foreach (int tempid in parentidlist)
        //        {
        //            bll.UpdateField(tempid, "is_allow=1");
        //        }
        //    }
        //    else
        //    {
        //        List<int> childidlist = new BLL.article_publish_category().GetChildIDList(id);
        //        childidlist.Add(id);
        //        foreach (int tempid in childidlist)
        //        {
        //            bll.UpdateField(tempid, "is_allow=0");
        //        }
        //    }

        //    //设置允许的会员
        //    List<string> strNeedAddUserGroupID = new List<string>();  //需要增加的ID;
        //    List<string> strNeedDeleteUserGroupID = new List<string>(); //需要删除的ID;
        //    List<string> strCommonUserGroupID = new List<string>(); //共同的ID;
        //    if (!string.IsNullOrEmpty(strnewusergroupidlist) && strnewusergroupidlist != allowuserid)
        //    {
        //        string[] newlist = strnewusergroupidlist.Split(',');

        //        #region 找出共同的部分
        //        foreach (string nid in newlist)
        //        {
        //            if (nid != "")
        //            {
        //                if (!string.IsNullOrEmpty(allowuserid))
        //                {
        //                    string[] oldlist = allowuserid.Split(',');
        //                    foreach (string oid in oldlist)
        //                    {
        //                        if (nid == oid)
        //                        {
        //                            strCommonUserGroupID.Add(oid);
        //                        }
        //                    }
        //                }
        //            }
        //        }
        //        #endregion

        //        #region 筛选出需要添加的id
        //        foreach (string nid in newlist)
        //        {
        //            if (nid != "")
        //            {
        //                int tempcount = 0;
        //                if (strCommonUserGroupID != null && strCommonUserGroupID.Count > 0)
        //                {
        //                    foreach (string tid in strCommonUserGroupID)
        //                    {
        //                        if (nid == tid)
        //                        {
        //                            tempcount = 1;
        //                        }
        //                    }
        //                }
        //                if(tempcount < 1)
        //                {
        //                    strNeedAddUserGroupID.Add(nid);
        //                }
        //            }
        //        }
        //        #endregion

        //        #region 筛选出需要删除的id
        //        if (!string.IsNullOrEmpty(allowuserid))
        //        {
        //            string[] oldlist = allowuserid.Split(',');
        //            foreach (string oid in oldlist)
        //            {
        //                if (oid != "")
        //                {
        //                    int tempcount = 0;
        //                    if (strCommonUserGroupID != null && strCommonUserGroupID.Count > 0)
        //                    {
        //                        foreach (string tid in strCommonUserGroupID)
        //                        {
        //                            if (oid == tid)
        //                            {
        //                                tempcount = 1;
        //                            }
        //                        }
        //                    }
        //                    if (tempcount < 1)
        //                    {
        //                        strNeedDeleteUserGroupID.Add(oid);
        //                    }
        //                }
        //            }
        //        }
        //        #endregion

        //        #region 更新操作
        //        List<int> childidlist = new BLL.article_publish_category().GetChildIDList(id);
        //        childidlist.Add(id);
        //        foreach (int tempid in childidlist)
        //        {
        //            Model.article_publish_category model = bll.GetModel(tempid);

        //            //增加操作
        //            if (strNeedAddUserGroupID != null && strNeedAddUserGroupID.Count > 0)
        //            {
                        
        //                foreach (string aid in strNeedAddUserGroupID)
        //                {
        //                    if (model.allow_usergroupid_list == "")
        //                    {
        //                        model.allow_usergroupid_list = ",";
        //                    }
        //                    model.allow_usergroupid_list = model.allow_usergroupid_list + aid + ",";
        //                }

        //            }
        //            //删除操作
        //            if (strNeedDeleteUserGroupID != null && strNeedDeleteUserGroupID.Count > 0)
        //            {
        //                foreach (string did in strNeedDeleteUserGroupID)
        //                {
        //                    model.allow_usergroupid_list = model.allow_usergroupid_list.Replace("," + did + ",", ",");
        //                }
        //                if (model.allow_usergroupid_list == ",")
        //                {
        //                    model.allow_usergroupid_list = "";
        //                }
        //            }
        //            bll.Update(model);
        //        }
        //        #endregion

        //    }
        //    context.Response.Write("{\"status\": 1, \"msg\": \"更新成功！\"}");
        //    return;
        //}



        /// <summary>
        /// 根据id列表获取用户组名列表
        /// </summary>
        private string GetUserNameList(string useridlist)
        {
            return useridlist;
        }

 

     

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}
