﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using DTcms.Common;

namespace DTcms.Web.Plugin.ArticlePublish
{

    public class articlepublish_article_list : Web.UI.UserPage
    {
        protected int page;         //当前页码
        protected int type_id;  //筛选类型ID, 0正常1未审核2锁定--->3回退9草稿
        protected int totalcount;   //OUT数据总数
        protected string pagelist;  //分页页码

        /// <summary>
        /// 重写虚方法,此方法将在Init事件前执行
        /// </summary>
        protected override void InitPage()
        {
            page = DTRequest.GetQueryInt("page", 1);
            type_id = DTRequest.GetQueryInt("typeid");
        }


        protected string get_channel_name(int id)
        {
            return new DTcms.BLL.channel().GetModel(id).title;
        }

        protected string get_category_name(int id)
        {
            return new DTcms.BLL.article_category().GetModel(id).title;
        }

        //查找匹配的URL
        protected string get_url_rewrite(int channel_id, int id)
        {
            if (channel_id == 0)
            {
                return string.Empty;
            }
            string querystring = id.ToString();
            string channel_name = new DTcms.BLL.channel().GetChannelName(channel_id);
            if (string.IsNullOrEmpty(channel_name))
            {
                return string.Empty;
            }
            DTcms.BLL.url_rewrite bll = new DTcms.BLL.url_rewrite();
            DTcms.Model.url_rewrite model = bll.GetInfo(channel_name, "detail");
            if (model != null)
            {
                return linkurl(model.name, querystring);
            }
            return string.Empty;
        }

        /// <summary>
        /// 短信息分页列表
        /// </summary>
        /// <param name="page_size">页面大小</param>
        /// <param name="page_index">当前页码</param>
        /// <param name="strwhere">查询条件</param>
        /// <param name="totalcount">总记录数</param>
        /// <returns>DateTable</returns>
        protected DataTable get_articlepublish_article_list(string username, int page_size, int page_index, string strwhere, string filedOrder, out int totalcount)
        {
            string tempstrwhere = "is_sys=0 and user_name='"+ username + "' and " + strwhere;
            return new DTcms.BLL.article().GetList(0, 0, page_size, page_index, tempstrwhere, filedOrder, out totalcount).Tables[0];
        }


        protected int get_article_count(string username, int status)
        {
            string strWhere;
            strWhere = "user_name = '" + username + "' and status = " + status;
            return new DTcms.BLL.article().GetCount(strWhere);
        }
    }
}
